{ Copyright (C) 1998-2000, written by Shkolnik Mike
  FIDOnet: 2:463/106.14
  E-Mail:  mshkolnik@scalabium.com
           mshkolnik@yahoo.com
  WEB: http://www.scalabium.com
       http://www.geocities.com/mshkolnik
  tel: 380-/44/-552-10-29

      -:
  TSMColorsCombo -    
  TSMFontNamesCombo -    
  TSMFontSizesCombo -     
  TSMBrushPenStyleCombo -       

    TSMColorsCombo   :
    ColorMode = set of (cmColor, cmName, cmStandardColors, cmSystemColors),
    
      -cmColor     (  )
      -cmName     (    ColorNames)
      -cmStandardColors    16   ( clBlack  clWhite)
      -cmSystemColors    25   ( clScrollbar  clSkyBlue)
    cmColor,   cmName     


    TSMFontNamesCombo ( RxFontComboBox)     .
    Device:
      -fdScreen    
      -fdPrinter    
      -fdBoth       
    Options = set of (foAnsiOnly, foTrueTypeOnly, foFixedPitchOnly,
                      foNoOEMFonts, foOEMFontsOnly, foScalableOnly);
      -foAnsiOnly - If True, the user can select fonts that use the Windows character
                    set only; that is, the user can't choose a font that contains only
                    symbols because they aren't displayed in the Font combo box.
      -foTrueTypeOnly - If True, only TrueType fonts are displayed in the Font combo box.
      -foFixedPitchOnly - If True, only monospaced fonts are displayed in the Font combo box.
      -foNoOEMFonts - If True, only fonts that aren't vector fonts are displayed in the Font combo box.
      -foOEMFontsOnly - If True, only OEM fonts are displayed in the Font combo box.
      -foScalableOnly - If True, only fonts that can be scaled are displayed in the Font combo box.

     FontSizesCombo  TSMFontSizesCombo    
     .


    TSMFontSizesCombo       
  .      FontName    Items 
       .

       TSMFontnamesCombo.


    TSMBrushPenStyleCombo   
    Brush  Pen     BrushPenMode.
     ShowNames     
   (    BrushNames  PenNames)
}
unit SMCombo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TColorMode = set of (cmColor, cmName, cmStandardColors, cmSystemColors);

  { TSMColorsCombo}
  TSMColorsCombo = class(TCustomComboBox)
  private
    { Private declarations }
    FColorValue: TColor;
    FColorNames: TStrings;
    FColorMode: TColorMode;

    FOnChange: TNotifyEvent;
    procedure SetColorValue(NewValue: TColor);
    procedure SetColorNames(Value: TStrings);
    procedure SetColorMode(Value: TColorMode);
    procedure ColorNamesChanged(Sender: TObject);
    procedure ResetItemHeight;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
  protected
    { Protected declarations }
    procedure CreateWnd; override;
    procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState); override;
    procedure Click; override;
    procedure BuildList; virtual;
    procedure DoChange; dynamic;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Text;
  published
    { Published declarations }
    property ColorValue: TColor read FColorValue write SetColorValue
      default clBlack;
    property ColorMode: TColorMode read FColorMode write SetColorMode;
    property ColorNames: TStrings read FColorNames write SetColorNames;
    property Color;
    property Ctl3D;
    property DragMode;
    property DragCursor;
    property Enabled;
    property Font;
    property ImeMode;
    property ImeName;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnDropDown;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnStartDrag;
  end;

{ TSMFontSizesCombo }

  TSMFontSizesCombo = class(TCustomComboBox)
  private
    FOnChange: TNotifyEvent;
    FUpdate: Boolean;
    FFontName: string;
    function GetFontName: TFontName;
    procedure SetFontName(NewFontName: TFontName);
  protected
    procedure BuildList; virtual;
    procedure Click; override;
    procedure DoChange; dynamic;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property FontName: TFontName read GetFontName write SetFontName;
    property Color;
    property Ctl3D;
    property DragMode;
    property DragCursor;
    property DropDownCount;
    property Enabled;
    property Font;
    property ImeMode;
    property ImeName;
    property ItemHeight;
    property MaxLength;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property Style;
    property TabOrder;
    property TabStop;
    property Text;
    property Visible;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnDrawItem;
    property OnDropDown;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMeasureItem;
    property OnStartDrag;
  end;


{ TSMFontNamesCombo }

  TSMFontDevice = (fdScreen, fdPrinter, fdBoth);
  TSMFontListOptions = set of (foAnsiOnly, foTrueTypeOnly, foFixedPitchOnly,
                               foNoOEMFonts, foOEMFontsOnly, foScalableOnly);

  TSMFontNamesCombo = class(TCustomComboBox)
  private
    FFontSizesCombo: TSMFontSizesCombo;

    FTrueTypeBMP: TBitmap;
    FDeviceBMP: TBitmap;
    FOnChange: TNotifyEvent;
    FDevice: TSMFontDevice;
    FUpdate: Boolean;
    FOptions: TSmFontListOptions;
    procedure SetFontName(const NewFontName: TFontName);
    function GetFontName: TFontName;
    procedure SetDevice(Value: TSMFontDevice);
    procedure SetOptions(Value: TSMFontListOptions);
    procedure ResetItemHeight;
    procedure Reset;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
    procedure WMFontChange(var Message: TMessage); message WM_FONTCHANGE;
  protected
    procedure BuildList; virtual;
    procedure Click; override;
    procedure DoChange; dynamic;
    procedure CreateWnd; override;
    procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Text;
  published
    property FontSizesCombo: TSMFontSizesCombo read  FFontSizesCombo write FFontSizesCombo;
    property Device: TSMFontDevice read FDevice write SetDevice default fdScreen;
    property FontName: TFontName read GetFontName write SetFontName;
    property Options: TSMFontListOptions read FOptions write SetOptions default [];
    property Color;
    property Ctl3D;
    property DragMode;
    property DragCursor;
    property Enabled;
    property Font;
    property ImeMode;
    property ImeName;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnDropDown;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnStartDrag;
  end;

{ TSMBrushPenStyleCombo }

  TSMBrushPenMode = (bpmBrush, bpmPen);

  TSMBrushPenStyleCombo = class(TCustomComboBox)
  private
    { Private declarations }

    FBrushPenMode: TSMBrushPenMode;
    FBrushStyle: TBrushStyle;
    FPenStyle: TPenStyle;
    FBrushNames: TStrings;
    FPenNames: TStrings;
    FShowNames: Boolean;

    FOnChange: TNotifyEvent;
    procedure SetBrushStyle(Value: TBrushStyle);
    procedure SetPenStyle(Value: TPenStyle);
    procedure SetBrushNames(Value: TStrings);
    procedure SetPenNames(Value: TStrings);
    procedure SetShowNames(Value: Boolean);
    procedure SetBrushPenMode(Value: TSMBrushPenMode);
    procedure DisplayNamesChanged(Sender: TObject);
    procedure ResetItemHeight;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
  protected
    { Protected declarations }
    procedure CreateWnd; override;
    procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState); override;
    procedure Click; override;
    procedure BuildList; virtual;
    procedure DoChange; dynamic;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Text;
  published
    { Published declarations }
    property BrushStyle: TBrushStyle read FBrushStyle write SetBrushStyle;
    property PenStyle: TPenStyle read FPenStyle write SetPenStyle;
    property BrushNames: TStrings read FBrushNames write SetBrushNames;
    property PenNames: TStrings read FPenNames write SetPenNames;
    property ShowNames: Boolean read FShowNames write SetShowNames;
    property BrushPenMode: TSMBrushPenMode read FBrushPenMode write SetBrushPenMode;

    property Items;

    property Color;
    property Ctl3D;
    property DragMode;
    property DragCursor;
    property Enabled;
    property Font;
    property ImeMode;
    property ImeName;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnDropDown;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnStartDrag;
  end;

procedure Register;

implementation
uses Printers, Typinfo;
{$R *.RES}

procedure Register;
begin
  RegisterComponents('SMComponents', [TSMColorsCombo, TSMFontNamesCombo, TSMFontSizesCombo, TSMBrushPenStyleCombo]);
end;

function GetItemHeight(Font: TFont): Integer;
var
  DC: HDC;
  SaveFont: HFont;
  Metrics: TTextMetric;
begin
  DC := GetDC(0);
  try
    SaveFont := SelectObject(DC, Font.Handle);
    GetTextMetrics(DC, Metrics);
    SelectObject(DC, SaveFont);
  finally
    ReleaseDC(0, DC);
  end;
  Result := Metrics.tmHeight + 1;
end;

{ TSMColorsCombo }

const
  ColorsInList = 41;
  ColorValues: array [0..ColorsInList - 1] of TColor = (
    clBlack, clMaroon, clGreen, clOlive, clNavy, clPurple, clTeal, clGray,
    clSilver, clRed, clLime, clYellow, clBlue, clFuchsia, clAqua, clWhite,
    clScrollBar, clBackground, clActiveCaption, clInactiveCaption,
    clMenu, clWindow, clWindowFrame, clMenuText, clWindowText, clCaptionText,
    clActiveBorder, clInactiveBorder, clAppWorkSpace, clHighlight,
    clHighlightText, clBtnFace, clBtnShadow, clGrayText, clBtnText,
    clInactiveCaptionText, clBtnHighlight, cl3DDkShadow, cl3DLight,
    clInfoText, clInfoBk);

constructor TSMColorsCombo.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  Style := csOwnerDrawFixed;
  FColorValue := clBlack;  { make default color selected }
  FColorNames := TStringList.Create;
  TStringList(FColorNames).OnChange := ColorNamesChanged;
  FColorMode := [cmColor, cmName, cmStandardColors, cmSystemColors];
end;

destructor TSMColorsCombo.Destroy;
begin
  TStringList(FColorNames).OnChange := nil;
  FColorNames.Free;
  FColorNames := nil;

  inherited Destroy;
end;

procedure TSMColorsCombo.CreateWnd;
begin
  inherited CreateWnd;

  BuildList;
  SetColorValue(FColorValue);
end;

procedure TSMColorsCombo.BuildList;
var i, intStart, intEnd: Integer;
    ColorName: string;
begin
  Clear;
  if (cmStandardColors in FColorMode) then
  begin
    intStart := 0;
    i := 16
  end
  else
  begin
    intStart := 16;
    i := 0
  end;
  if (cmSystemColors in FColorMode) then
    Inc(i, 25);
  intEnd := intStart + i - 1;

  for i := intStart to intEnd do
  begin
    if (i <= Pred(FColorNames.Count)) and (FColorNames[i] <> '') then
      ColorName := FColorNames[i]
    else
      { delete two first characters which prefix "cl" educated }
      ColorName := Copy(ColorToString(ColorValues[i]), 3, MaxInt);
    Items.AddObject(ColorName, TObject(ColorValues[i]));
  end;
end;

procedure TSMColorsCombo.ColorNamesChanged(Sender: TObject);
begin
  if HandleAllocated then
  begin
    FColorValue := ColorValue;
    RecreateWnd;
  end;
end;

procedure TSMColorsCombo.SetColorNames(Value: TStrings);
begin
  FColorNames.Assign(Value);
end;

procedure TSMColorsCombo.SetColorValue(NewValue: TColor);
var i: Integer;
    CurrentColor: TColor;
begin
  if (ItemIndex < 0) or (NewValue <> FColorValue) then
    { change selected item }
    for i := 0 to Pred(Items.Count) do
    begin
      CurrentColor := TColor(Items.Objects[i]);
      if CurrentColor = NewValue then
      begin
        FColorValue := NewValue;
        if ItemIndex <> i then
          ItemIndex := i;
        DoChange;
        Break;
      end;
    end;
end;

procedure TSMColorsCombo.SetColorMode(Value: TColorMode);
begin
  if (FColorMode <> Value) then
  begin
    FColorMode := Value;
    Invalidate;
  end;
end;

procedure TSMColorsCombo.DrawItem(Index: Integer; Rect: TRect;
  State: TOwnerDrawState);
const
  ColorWidth = 22;
var ARect: TRect;
    Text: array[0..255] of Char;
    Safer: TColor;
begin
  ARect := Rect;
  Inc(ARect.Top, 2);
  Inc(ARect.Left, 2);
  Dec(ARect.Bottom, 2);
  if (cmColor in FColorMode) and
     (cmName in FColorMode) then
    ARect.Right := ARect.Left + ColorWidth
  else
    Dec(ARect.Right, 3);
  with Canvas do
  begin
    FillRect(Rect);

    if (cmColor in FColorMode) then
    begin
      Safer := Brush.Color;
      Pen.Color := clWindowText;
      Rectangle(ARect.Left, ARect.Top, ARect.Right, ARect.Bottom);
      Brush.Color := TColor(Items.Objects[Index]);
      try
        InflateRect(ARect, -1, -1);
        FillRect(ARect);
      finally
        Brush.Color := Safer;
      end;
    end;
    if (cmName in FColorMode) then
    begin
      StrPCopy(Text, Items[Index]);
      if (cmColor in FColorMode) then
        Rect.Left := Rect.Left + ColorWidth + 6
      else
      begin
        Font.Color := TColor(Items.Objects[Index]);
        Rect.Left := Rect.Left + 6
      end;
      DrawText(Canvas.Handle, Text, StrLen(Text), Rect, DT_SINGLELINE or
        DT_VCENTER or DT_NOPREFIX);
    end;
  end;
end;

procedure TSMColorsCombo.Click;
begin
  if ItemIndex >= 0 then
    ColorValue := TColor(Items.Objects[ItemIndex]);

  inherited Click;
end;

procedure TSMColorsCombo.CMFontChanged(var Message: TMessage);
begin
  inherited;

  ResetItemHeight;
  RecreateWnd;
end;

procedure TSMColorsCombo.ResetItemHeight;
var i: Integer;
begin
  i := GetItemHeight(Font);
  if i > 9 then
    ItemHeight := i
  else
    ItemHeight := 9;
end;

procedure TSMColorsCombo.DoChange;
begin
  if Assigned(FOnChange) then
    FOnChange(Self);
end;


{ TSMFontSizesCombo }
{ Big thanx for Alexander Fyodorov, 2:5030/613.6. }
const szSizeArray = 16;
      PointSizes: array[0..szSizeArray-1] of Integer =
                   (8, 9, 10, 11, 12, 14, 16, 18, 20, 22, 24, 26, 28, 36, 48, 72);
var boolTrueType: Boolean;

function SetFontTypeFlag(var LogFont: TEnumLogFont; var ptm: TNewTextMetric;
      FontType: integer; Data: Pointer): Integer; stdcall;
begin
  boolTrueType := (ptm.tmPitchAndFamily and TMPF_TRUETYPE) = TMPF_TRUETYPE;
  Result := 0;
end;

function IsTrueType(FontName : string) : boolean;
var DC: HDC;
begin
  DC := GetDC(0);
  EnumFontFamilies(DC, PChar(FontName), @SetFontTypeFlag, 0);
  Result := boolTrueType;
  ReleaseDC(0, DC);
end;

function FillFontSizes(var LogFont: TEnumLogFont; var ptm: TNewTextMetric;
                     FontType: Integer; Data: Pointer): Integer; stdcall;
var s: string;
    i: Integer;
begin
  i := MulDiv(LogFont.elfLogFont.lfHeight, 72, Screen.PixelsPerInch { PPI});
  s := IntToStr(i);
  if TStrings(Data).IndexOf(s) = -1 then
    TStrings(Data).Add(s);
  Result := 1;
end;

constructor TSMFontSizesCombo.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

//  Sorted := True;
  FUpdate := False;
end;

procedure TSMFontSizesCombo.BuildList;
var DC: hDC;
    i: Integer;
begin
  Items.Clear;
  if IsTrueType(FFontName) then
  begin
    for i := 0 to szSizeArray-1 do
      Items.Add(IntToStr(PointSizes[i]));
  end
  else
  begin
    DC := GetDC(0);
    EnumFontFamilies(DC, PChar(FFontName), @FillFontSizes, Longint(Items));
    ReleaseDC(0, DC);
  end;
end;

procedure TSMFontSizesCombo.SetFontName(NewFontName: TFontName);
begin
  if (FontName <> NewFontName) then
  begin
    FFontName := NewFontName;
    BuildList;
  end;
end;

function TSMFontSizesCombo.GetFontName: TFontName;
begin
  Result := FFontName;
end;

procedure TSMFontSizesCombo.Click;
begin
  inherited Click;

  DoChange;
end;

procedure TSMFontSizesCombo.DoChange;
begin
  if not FUpdate and Assigned(FOnChange) then
    FOnChange(Self);
end;


{ TSMFontNamesCombo }

function EnumFontsProc(var LogFont: TLogFont; var TextMetric: TTextMetric;
  FontType: Integer; Data: Pointer): Integer; export;
  {$IFDEF WIN32} stdcall; {$ENDIF}
var
  Box: TSMFontNamesCombo;

  function IsValidFont: Boolean;
  begin
    Result := True;
    if foAnsiOnly in Box.Options then
      Result := Result and (LogFont.lfCharSet = ANSI_CHARSET);
    if foTrueTypeOnly in Box.Options then
      Result := Result and (FontType and TRUETYPE_FONTTYPE = TRUETYPE_FONTTYPE);
    if foFixedPitchOnly in Box.Options then
      Result := Result and (LogFont.lfPitchAndFamily and FIXED_PITCH = FIXED_PITCH);
    if foOEMFontsOnly in Box.Options then
      Result := Result and (LogFont.lfCharSet = OEM_CHARSET);
    if foNoOEMFonts in Box.Options then
      Result := Result and (LogFont.lfCharSet <> OEM_CHARSET);
    if foScalableOnly in Box.Options then
      Result := Result and (FontType and RASTER_FONTTYPE = 0);
  end;

begin
  Box := TSMFontNamesCombo(Data);
  if (Box.Items.IndexOf(StrPas(LogFont.lfFaceName)) < 0) and IsValidFont then
    Box.Items.AddObject(StrPas(LogFont.lfFaceName), TObject(FontType));
  Result := 1;
end;

constructor TSMFontNamesCombo.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FFontSizesCombo := nil;

  FTrueTypeBMP := TBitmap.Create;
  try
    FTrueTypeBMP.LoadFromResourceName(hInstance, 'TRUETYPE_FNT');
  except
    FTrueTypeBMP.Free;
    FTrueTypeBMP := nil;
  end;

  FDeviceBMP := TBitmap.Create;
  try
    FDeviceBMP.LoadFromResourceName(hInstance, 'DEVICE_FNT');
  except
    FDeviceBMP.Free;
    FDeviceBMP := nil;
  end;

  FDevice := fdScreen;
  Style := csOwnerDrawFixed;
  Sorted := True;
  FUpdate := False;
  ResetItemHeight;
end;

destructor TSMFontNamesCombo.Destroy;
begin
  FTrueTypeBMP.Free;
  FDeviceBMP.Free;

  inherited Destroy;
end;

procedure TSMFontNamesCombo.BuildList;
var DC: HDC;
    Proc: TFarProc;
begin
  if not HandleAllocated then Exit;
  Clear;
  DC := GetDC(0);
  try
    Proc := MakeProcInstance(@EnumFontsProc, HInstance);
    try
      if (FDevice = fdScreen) or (FDevice = fdBoth) then
        EnumFonts(DC, nil, Proc, Pointer(Self));
      if (FDevice = fdPrinter) or (FDevice = fdBoth) then
        try
          EnumFonts(Printer.Handle, nil, Proc, Pointer(Self));
        except
          { skip any errors }
        end;
    finally
      FreeProcInstance(Proc);
    end;
  finally
    ReleaseDC(0, DC);
  end;
end;

procedure TSMFontNamesCombo.SetFontName(const NewFontName: TFontName);
var i, Item: Integer;
begin
  if (FontName <> NewFontName) then
  begin
    HandleNeeded;
    { change selected item }
    i := -1;
    for Item := 0 to Items.Count - 1 do
      if (AnsiUpperCase(Items[Item]) = AnsiUpperCase(NewFontName)) then
      begin
        i := Item;
        Break;
      end;
    ItemIndex := i;
    DoChange;
  end;
end;

function TSMFontNamesCombo.GetFontName: TFontName;
begin
  Result := Text;
end;

procedure TSMFontNamesCombo.SetOptions(Value: TSMFontListOptions);
begin
  if (Value <> Options) then
  begin
    FOptions := Value;
    Reset;
  end;
end;

procedure TSMFontNamesCombo.SetDevice(Value: TSMFontDevice);
begin
  if (Value <> FDevice) then
  begin
    FDevice := Value;
    Reset;
  end;
end;

procedure TSMFontNamesCombo.CreateWnd;
var OldFont: TFontName;
begin
  OldFont := FontName;

  inherited CreateWnd;

  BuildList;
  SetFontName(OldFont);
end;

procedure TSMFontNamesCombo.DrawItem(Index: Integer; Rect: TRect;
  State: TOwnerDrawState);
var
  Bitmap: TBitmap;
  BmpWidth: Integer;
  Text: array[0..255] of Char;
begin
  with Canvas do
  begin
    FillRect(Rect);
    BmpWidth  := 20;
    if (Integer(Items.Objects[Index]) and TRUETYPE_FONTTYPE) <> 0 then
      Bitmap := FTrueTypeBMP
    else
     if (Integer(Items.Objects[Index]) and DEVICE_FONTTYPE) <> 0 then
       Bitmap := FDeviceBMP
     else
       Bitmap := nil;
    if Bitmap <> nil then
    begin
      BmpWidth := Bitmap.Width;
      BrushCopy(Bounds(Rect.Left + 2, (Rect.Top + Rect.Bottom - Bitmap.Height) div 2,
                Bitmap.Width, Bitmap.Height), Bitmap,
                Bounds(0, 0, Bitmap.Width, Bitmap.Height), Bitmap.TransparentColor);
    end;
    StrPCopy(Text, Items[Index]);
    Rect.Left := Rect.Left + BmpWidth + 6;
    DrawText(Canvas.Handle, Text, StrLen(Text), Rect,
             DT_SINGLELINE or DT_VCENTER or DT_NOPREFIX);
  end;
end;

procedure TSMFontNamesCombo.WMFontChange(var Message: TMessage);
begin
  inherited;

  Reset;
end;

procedure TSMFontNamesCombo.CMFontChanged(var Message: TMessage);
begin
  inherited;

  ResetItemHeight;
  RecreateWnd;
end;

procedure TSMFontNamesCombo.ResetItemHeight;

  function MaxInteger(const Values: array of Longint): Longint;
  var i: Cardinal;
  begin
    Result := Values[0];
    for i := 0 to High(Values) do
      if Values[i] > Result then
        Result := Values[i];
  end;

begin
  ItemHeight := MaxInteger([GetItemHeight(Font), FTrueTypeBMP.Height - 1, 9]);
end;

procedure TSMFontNamesCombo.Click;
begin
  inherited Click;

  DoChange;
end;

procedure TSMFontNamesCombo.DoChange;
begin
  if Assigned(FFontSizesCombo) then
    FFontSizesCombo.FontName := FontName;

  if not FUpdate and Assigned(FOnChange) then
    FOnChange(Self);
end;

procedure TSMFontNamesCombo.Reset;
var SaveName: TFontName;
begin
  if HandleAllocated then
  begin
    FUpdate := True;
    try
      SaveName := FontName;
      BuildList;
      FontName := SaveName;
    finally
      FUpdate := False;
      if (FontName <> SaveName) then
        DoChange;
    end;
  end;
end;


{ TSMBrushPenStyleCombo }

constructor TSMBrushPenStyleCombo.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  Style := csOwnerDrawFixed;
  FBrushStyle := bsSolid;  { make default brush style selected }
  FPenStyle := psSolid;  { make default pen style selected }
  FBrushNames := TStringList.Create;
  TStringList(FBrushNames).OnChange := DisplayNamesChanged;

  FPenNames := TStringList.Create;
  TStringList(FPenNames).OnChange := DisplayNamesChanged;

  FShowNames := True;
end;

destructor TSMBrushPenStyleCombo.Destroy;
begin
  TStringList(FBrushNames).OnChange := nil;
  FBrushNames.Free;
  FBrushNames := nil;

  TStringList(FPenNames).OnChange := nil;
  FPenNames.Free;
  FPenNames := nil;

  inherited Destroy;
end;

procedure TSMBrushPenStyleCombo.CreateWnd;
begin
  inherited CreateWnd;

  BuildList;
  if (FBrushPenMode = bpmBrush) then
    SetBrushStyle(FBrushStyle)
  else
    SetPenStyle(FPenStyle);
end;

procedure TSMBrushPenStyleCombo.BuildList;
var i: Integer;
    ItemName: string;
begin
  Clear;

  if (FBrushPenMode = bpmBrush) then
    for i := 0 to Pred(Integer(bsDiagCross)) do
    begin
      if (i <= Pred(FBrushNames.Count)) and (FBrushNames[i] <> '') then
        ItemName := FBrushNames[i]
      else
        { delete two first characters which prefix "bs" educated }
        ItemName := Copy(GetEnumName(TypeInfo(TBrushStyle), i), 3, 10);
      Items.AddObject(ItemName, TObject(TBrushStyle(i)));
    end
  else
    for i := 0 to Pred(Integer(psInsideFrame)) do
    begin
      if (i <= Pred(FPenNames.Count)) and (FPenNames[i] <> '') then
        ItemName := FPenNames[i]
      else
        { delete two first characters which prefix "ps" educated }
        ItemName := Copy(GetEnumName(TypeInfo(TPenStyle), i), 3, 10);
      Items.AddObject(ItemName, TObject(TPenStyle(i)));
    end
end;

procedure TSMBrushPenStyleCombo.DisplayNamesChanged(Sender: TObject);
begin
  if HandleAllocated then
  begin
    if (FBrushPenMode = bpmBrush) then
      FBrushStyle := BrushStyle
    else
      FPenStyle := PenStyle;
    ReCreateWnd;
  end;
end;

procedure TSMBrushPenStyleCombo.SetBrushNames(Value: TStrings);
begin
  FBrushNames.Assign(Value);
end;

procedure TSMBrushPenStyleCombo.SetPenNames(Value: TStrings);
begin
  FPenNames.Assign(Value);
end;

procedure TSMBrushPenStyleCombo.SetBrushPenMode(Value: TSMBrushPenMode);
begin
  if (FBrushPenMode <> Value) then
  begin
    FBrushPenMode := Value;
    BuildList;
    Invalidate
  end;
end;

procedure TSMBrushPenStyleCombo.SetBrushStyle(Value: TBrushStyle);
var i: Integer;
    bs: TBrushStyle;
begin
  if (ItemIndex < 0) or (FBrushStyle <> Value) then
    { change selected item }
    for i := 0 to Pred(Items.Count) do
    begin
      bs := TBrushStyle(Items.Objects[i]);
      if bs = Value then
      begin
        FBrushStyle := Value;
        if ItemIndex <> i then
          ItemIndex := i;
        DoChange;
        Break;
      end;
    end;
end;

procedure TSMBrushPenStyleCombo.SetPenStyle(Value: TPenStyle);
var i: Integer;
    ps: TPenStyle;
begin
  if (ItemIndex < 0) or (FPenStyle <> Value) then
    { change selected item }
    for i := 0 to Pred(Items.Count) do
    begin
      ps := TPenStyle(Items.Objects[i]);
      if ps = Value then
      begin
        FPenStyle := Value;
        if ItemIndex <> i then
          ItemIndex := i;
        DoChange;
        Break;
      end;
    end;
end;

procedure TSMBrushPenStyleCombo.SetShowNames(Value: Boolean);
begin
  if (FShowNames <> Value) then
  begin
    FShowNames := Value;
    Invalidate
  end;
end;

procedure TSMBrushPenStyleCombo.DrawItem(Index: Integer; Rect: TRect;
  State: TOwnerDrawState);
const
  BrushWidth = 22;
  PenWidth = 60;
var ARect: TRect;
    Text: array[0..255] of Char;
    RectWidth, foldbk: integer;
begin
  if (FBrushPenMode = bpmBrush) then
    RectWidth := BrushWidth
  else
    RectWidth := PenWidth;

  ARect := Rect;
  Inc(ARect.Top, 2);
  Inc(ARect.Left, 2);
  Dec(ARect.Bottom, 2);
  if FShowNames then
    ARect.Right := ARect.Left + RectWidth
  else
    Dec(ARect.Right, 3);

  with Canvas do
  begin
    FillRect(Rect);
    Pen.Color := clBlack;

    if (FBrushPenMode = bpmPen) then
    begin
      Pen.Style := TPenStyle(index);
      MoveTo(ARect.Left, (ARect.Top + ARect.Bottom) div 2);
      LineTo(ARect.Right, (ARect.Top + ARect.Bottom) div 2);
    end
    else
    begin
      Rectangle(ARect.Left, ARect.Top, ARect.Right, ARect.Bottom);
      InflateRect(ARect, -1, -1);

      foldbk := SetBkColor(Handle, ColorToRGB(clInfoBk));

      if TBrushStyle(Index) = bsClear then
      begin
        Brush.Color := clInfoBk;
        Brush.Style := bsSolid;
      end
      else
      begin
        Brush.Color := clBlack;
        Brush.Style := TBrushStyle(Index);
      end;
      Windows.FillRect(Handle, ARect, Brush.Handle);

      SetBkColor(Handle, foldbk);
    end;

    StrPCopy(Text, Items[Index]);
    if FShowNames then
    begin
      Rect.Left := Rect.Left + RectWidth + 6;
      DrawText(Canvas.Handle, Text, Length(Text), Rect,
               DT_SINGLELINE or DT_VCENTER or DT_NOPREFIX);
    end;
  end;
end;

procedure TSMBrushPenStyleCombo.Click;
begin
  if ItemIndex >= 0 then
    if (FBrushPenMode = bpmBrush) then
      FBrushStyle := TBrushStyle(ItemIndex)
    else
      FPenStyle := TPenStyle(ItemIndex);

  inherited Click;

  DoChange;
end;

procedure TSMBrushPenStyleCombo.CMFontChanged(var Message: TMessage);
begin
  inherited;

  ResetItemHeight;
  RecreateWnd;
end;

procedure TSMBrushPenStyleCombo.ResetItemHeight;
var i: Integer;
begin
  i := GetItemHeight(Font);
  if i > 9 then
    ItemHeight := i
  else
    ItemHeight := 9;
end;

procedure TSMBrushPenStyleCombo.DoChange;
begin
  if Assigned(FOnChange) then
    FOnChange(Self);
end;

end.
